// MONÔMERO///

class Monomero{
  
  float xpos, ypos, //coordenadas do centro da ligação dupla principal do monômero
  
        angle, //ângulo de abertura da ligação dupla
  
        inc; //inclinação do monômero em relação ao eixo horizontal
  
  float l; //viável utilizada para alternar os sentidos de monômeros sucessivos (assume os valores '1' ou '-1')
  
  //CONSTRUTORA//
  Monomero(float x, float y, float teta){
    xpos = x;
    ypos = y;
    inc = teta;
    angle = 0;
    l = lado;
    lado = -lado;    
  }
  
  //para facilitar a mudança do polímero a ser apresentado, criamos uma função display() para cada
  //espécie quimica diferente

  //ETILENO
  void displayEthylene(){
    
    float offset = (comprimento/30)*(PI - angle)/PI; //distância interna à ligação dupla
    
    if(angle == PI)
      offset = 0;     //sistema de redundância
    
    pushMatrix();
    translate(xpos, ypos);//origem: centro da ligação dupla 
    rotate(inc);// gira de 'inc'
    
    //desenha as ligações centrais
    pushMatrix();
    translate(- (comprimento/4), offset);//origem: centro do átomo à esquerda da ligação, deslocado de 'offset'
    rotate(angle);// uma das partes da ligação dupla abre de um angulo 'angle'    
    stroke(0);
    line(0, 0, (comprimento/4), 0);//desenhamos a metade da esquerda da ligação inferior
    popMatrix();
    
    pushMatrix();
    translate((comprimento/4), offset);//origem: centro do átomo à direita da ligação, deslocado de 'offset'
    rotate(PI - angle); // a outra parte da ligação dupla abre para o outro lado, simetricamente
    line(0, 0, (comprimento/4), 0);//desenhamos a metade da direita da ligação inferior
    popMatrix();
    
    line(- (comprimento/4), - offset, (comprimento/4), - offset);//desenhamos a ligação superior
    
    //desenha os átomos e suas ligações
    pushMatrix();
    translate(- (comprimento/4), 0);//origem: centro do átomo à esquerda da ligação dupla
    pushMatrix();
    rotate((TWO_PI - angle/2)/3); //o ângulo das outras ligações dos átomos ligados pela ligação
                                  //dupla também dependem do valor de 'angle', uma vez que o 
                                  //átomo de carbono assume hibridizações distintas no monômero
                                  //e no polímero
                                  
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(122);//CINZA
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0); //origem: centro do átomo à direita da ligação dupla
    pushMatrix();
    rotate((PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate(-(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    popMatrix();
    
    fill(#91D6F7);//AZUL 
    ellipse(-(comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    popMatrix();
  }
  
  //TEFLON
  void displayTFEthylene(){
    
    // o procedimento de desenho é análogo ao do monômero de etileno
    
    float offset = (comprimento/30)*(PI - angle)/PI; //distância interna à ligação dupla
    
    if(angle == PI)
      offset = 0;  //sistema de redundância
    
    pushMatrix();
    translate(xpos, ypos);
    rotate(inc);
    
    //desenha as ligações centrais
    pushMatrix();
    translate(- (comprimento/4), offset);
    rotate(angle); //uma das partes da ligação dupla abre de um angulo 'angle'
    
    stroke(0);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    pushMatrix();
    translate((comprimento/4), offset);
    rotate(PI - angle);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    line(- (comprimento/4), - offset, (comprimento/4), - offset);
    
    //desenha os átomos e suas ligações
    pushMatrix();
    translate(- (comprimento/4), 0);
    pushMatrix();
    rotate((TWO_PI - angle/2)/3);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(#BC90FA);//ROXO
    ellipse((5*comprimento/12), 0, 1.2*(comprimento/5), 1.2*(comprimento/5)); //cloro
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, 1.2*(comprimento/5), 1.2*(comprimento/5)); //cloro
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0);
    pushMatrix();
    rotate((PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, 1.2*(comprimento/5), 1.2*(comprimento/5)); //cloro
    popMatrix();
    pushMatrix();
    rotate(-(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, 1.2*(comprimento/5), 1.2*(comprimento/5)); //cloro
    popMatrix();
    popMatrix();
    
    fill(#91D6F7);//AZUL
    ellipse(-(comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5));  //carbono
    popMatrix();
  }
  
   //PVC
   void displayPVC(){
    
    // o procedimento de desenho é análogo ao do monômero de etileno
    
    float offset = (comprimento/30)*(PI - angle)/PI;
    if(angle == PI)
      offset = 0;
    
    pushMatrix();
    translate(xpos, ypos);
    rotate(inc);
    //desenha as ligações centrais
    pushMatrix();
    translate(- (comprimento/4), offset);
    rotate(angle);//uma das partes da ligação dupla abre de um angulo 'angle'
    
    stroke(0);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    pushMatrix();
    translate((comprimento/4), offset);
    rotate(PI - angle);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    line(- (comprimento/4), - offset, (comprimento/4), - offset);
    
    //desenha os átomos e suas ligações
    pushMatrix();
    translate(- (comprimento/4), 0);
    pushMatrix();
    rotate((TWO_PI - angle/2)/3);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(122); //CINZA
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0);
    pushMatrix();
    rotate(l*(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate(l*(-(PI + angle/2)/3));
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(#BC90FA);//ROXO
    ellipse((5*comprimento/12), 0, 1.2*(comprimento/5), 1.2*(comprimento/5)); //cloro
    popMatrix();
    popMatrix();
    
    fill(#91D6F7); //AZUL
    ellipse(-(comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    popMatrix();
  }
  
  //PROPILENO  
  void displayPropylene(){
    
    // o procedimento de desenho é análogo ao do monômero de etileno
    
    float offset = (comprimento/30)*(PI - angle)/PI;
    if(angle == PI)
      offset = 0;
    
    pushMatrix();
    translate(xpos, ypos);
    rotate(inc);
    
    //desenha as ligações centrais
    pushMatrix();
    translate(- (comprimento/4), offset);
    rotate(angle);//uma das partes da ligação dupla abre de um angulo 'angle'
    stroke(0);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    
    pushMatrix();
    translate((comprimento/4), offset);
    rotate(PI - angle);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    line(- (comprimento/4), - offset, (comprimento/4), - offset);
    
    //desenha os átomos e suas ligações
    pushMatrix();
    translate(- (comprimento/4), 0);
    pushMatrix();
    rotate((TWO_PI - angle/2)/3);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(122); //CINZA
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0);
    pushMatrix();
    rotate(l*(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate(l*(-(PI + angle/2)/3));
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    //noStroke();
    //ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5));
    pushMatrix();
    translate((5*comprimento/12), 0);
    line(0, 0, (4*comprimento/12), 0);
    noStroke();
    ellipse((4*comprimento/12), 0, .9*(comprimento/5), .9*(comprimento/5)); //hidrogênio (este átomo aparece menor para que 
                                                                            //pareça mais distante, sendo que está atrás do
                                                                            //plano da ligação dupla)
    pushMatrix();
    rotate(-PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5));
    popMatrix();
    pushMatrix();
    rotate(PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    fill(#91D6F7); //AZUL
    ellipse(0, 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    popMatrix();
    
    popMatrix();
    popMatrix();
    
    fill(#91D6F7); //AZUL
    ellipse(-(comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    popMatrix();
  } 
  
  //ACRÍLICO
  void displayAcrylic(){
    
    // o procedimento de desenho é análogo ao do monômero de etileno
    
    float offset = (comprimento/30)*(PI - angle)/PI;
    if(angle == PI)
      offset = 0;
    
    pushMatrix();
    translate(xpos, ypos);
    rotate(inc);
    
    //desenha as ligações centrais
    pushMatrix();
    translate(- (comprimento/4), offset);
    rotate(angle);//uma das partes da ligação dupla abre de um angulo 'angle'
    
    stroke(0);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    pushMatrix();
    translate((comprimento/4), offset);
    rotate(PI - angle);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    line(- (comprimento/4), - offset, (comprimento/4), - offset);
    
    //desenha os átomos e suas ligações
    pushMatrix();
    translate(- (comprimento/4), 0);
    pushMatrix();
    rotate((TWO_PI - angle/2)/3);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(122); //CINZA
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0);
    pushMatrix();
    rotate(l*(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    //noStroke();
    //ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5));
    
    pushMatrix();//para desenhar a metila
    translate((5*comprimento/12), 0);
    line(0, 0, (4*comprimento/12), 0);
    noStroke();
    ellipse((4*comprimento/12), 0, .9*(comprimento/5), .9*(comprimento/5)); //hidrogênio
    pushMatrix();
    rotate(-PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate(PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    fill(#91D6F7);//AZUL
    ellipse(0, 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    popMatrix();
    popMatrix();//fim da metila
    
    pushMatrix();
    rotate(l*(-(PI + angle/2)/3));
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    //noStroke();
    //ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5));
    pushMatrix();
    translate((5*comprimento/12), 0);//pulamos para o carbono do radical
    pushMatrix();
    rotate(-PI/3);
    line(0, (comprimento/30), (5*comprimento/12), (comprimento/30));
    line(0, -(comprimento/30), (5*comprimento/12), -(comprimento/30));
    noStroke();
    fill(#FC928F); // ROSA
    ellipse((5*comprimento/12), 0, 1.1*(comprimento/5), 1.1*(comprimento/5));//desenhamos o oxigênio com ligação dupla
    popMatrix();
    pushMatrix();
    rotate(PI/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    translate((5*comprimento/12), 0);
    
    pushMatrix();//para desenhar a metila
    rotate(-PI/3);
    line(0, 0, (5*comprimento/12), 0);    
    translate((5*comprimento/12), 0);
    line(0, 0, (4*comprimento/12), 0);
    noStroke();
    fill(122); //CINZA
    ellipse((4*comprimento/12), 0, .9*(comprimento/5), .9*(comprimento/5)); //hidrogênio
    pushMatrix();
    rotate(-PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    pushMatrix();
    rotate(PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrogênio
    popMatrix();
    fill(#91D6F7);//AZUL
    ellipse(0, 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    popMatrix();
    fill(#FC928F); // ROSA
    ellipse(0, 0, 1.1*(comprimento/5), 1.1*(comprimento/5));//desenhamos o oxigênio
    popMatrix();//fim da metila
    
    fill(#91D6F7);//AZUL
    ellipse(0, 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    popMatrix();
    popMatrix();
    popMatrix();
    
    ellipse(-(comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); //carbono
    popMatrix();
  }
  
    //função que abre a ligação dupla
    void abrir(float omega){
      if(angle < PI)
        angle += omega;
      else
        angle = PI;  
    }
    
    //função que fecha a ligação dupla
    void fechar(float omega){
      if(angle >0)
      angle -= omega;
    } 
    
    //função que faz o monômero girar em relação ao eixo z
    void girar(float teta){
      inc += teta;
    }
    
    //função que faz o monômero se movimentar no plano xy
    void andar(float vx, float vy){
      xpos += vx;
      ypos += vy;
    }
    
    //devolve a distância entre este e um outro monômero 
    float distancia(Monomero m){
      return dist(xpos, ypos, m.xpos, m.ypos);
    }
}


