import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Polimerizacao_Cadeia extends PApplet {

Monomero[] m; //vetor de mon\u00f4meros 

Botao[] especie; //vetor de bot\u00f5es que definem o polimero a ser apresentado

Botao[] processo; //vetor de bot\u00f5es utilizados na din\u00e2mica da anima\u00e7\u00e3o

Credito credito;

PFont f; //fonte

float comprimento; //comprimento do mon\u00f4mero de refer\u00eancia (etileno) --> equivale ao dobro do comprimento da liga\u00e7\u00e3o dupla

float vx; //velocidade com que os radicais e os mon\u00f4meros se movimentam

//float omega; //velocidade angular de abertura da liga\u00e7\u00e3o (N\u00c3O UTILIZADO!)

String etapa; //guarda o nome da etapa da anima\u00e7\u00e3o que est\u00e1 sendo apresentada,
              //pode guardar "MON\u00d4MERO", "INICIA\u00c7\u00c3O", "PROPAGA\u00c7\u00c3O" ou "TERMINA\u00c7\u00c3O"

String polimero; //guarda o nome do polimero que esta sendo apresentado

//VARI\u00c1VEIS DA ANIMA\u00c7\u00c3O
float rx; //posi\u00e7\u00e3o no eixo X do iniciador
float rx_; //posi\u00e7\u00e3o no eixo X do terminador

float lado = 1; //bin\u00e1rio utilizado para gerenciar a altern\u00e2ncia dos sentidos de mon\u00f4meros sucessivos

//SETUP////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
public void setup(){
  size(700, 700);
  smooth();
  strokeWeight(3);
  textAlign(CENTER);
  
  //DEFINI\u00c7\u00c3O DAS CONSTANTES
  comprimento = 60;
  vx = 3;
 // omega = PI/100;
  
  //INICIALIZA\u00c7\u00d5ES
  f = loadFont("CourierNewPS-BoldMT-28.vlw"); 
  textFont(f, 38); //escrevemos o t\u00edtulo com uma letra maior
  
  etapa = "MON\u00d4MERO"; //primeiramente apresentamos o mon\u00f4mero isolado
  
  rx = - comprimento; //o radical surge de fora da tela, entrando pelo lado esquerdo
  
  polimero = "POLIETILENO"; //por ser o mon\u00f4mero mais simples, o polietileno foi escolhido
                            //para ser o pol\u00edmero cujo processo \u00e9 apresentado inicialmente
  
  //iniciamos a matriz de mon\u00f4meros
  m = new Monomero[1]; 
  m[0] = new Monomero(width/2, height/2 , 0); //colocamos o primeiro mon\u00f4mero no centro da tela
  
  //inicializa\u00e7\u00e3o dos bot\u00f5es dos pol\u00edmeros
  especie = new Botao[5];
  especie[0] = new Botao(width/2 - 2*120, height/4, "POLIETILENO");         //polietileno
    //o bot\u00e3o referente ao polietileno esta inicialmente selecionado
    especie[0].situacao = "SELECIONADO";
    especie[0].psituacao = "LIBERADO";
  especie[1] = new Botao(width/2 - 1*120, height/4, "TEFLON");              //teflon
  especie[2] = new Botao(width/2 - 0*120, height/4, "PVC");                 //PVC
  especie[3] = new Botao(width/2 + 1*120, height/4, "POLIPROPILENO");       //polipropileno
  especie[4] = new Botao(width/2 + 2*120, height/4, "ACR\u00cdLICO");            //acr\u00edlico
  
  //inicializa\u00e7\u00e3o dos bot\u00f5es de anima\u00e7\u00e3o
  processo = new Botao[2];
  processo[0] = new Botao(width/2 + 1*130, 7*height/10, "IN\u00cdCIO");           //in\u00edcio
    /*processo[0].situacao = "LIBERADO";
    processo[0].psituacao = "SELECIONADO";*/
  processo[1] = new Botao(width/2 + 2*130, 7*height/10, "AVAN\u00c7AR >>");       //avan\u00e7ar
  
  //inicializa\u00e7\u00e3o do bot\u00e3o de cr\u00e9ditos
  credito = new Credito();
  
  //inicializamos a tela (definindo o fundo branco) e escrevemos os textos uma \u00fanica vez
  //atualizando apenas a \u00e1rea em que a anima\u00e7\u00e3o ocorre por meio do desenho de um ret\u00e2ngulo
  //que cobre tal regi\u00e3o  
  
  background(255); // fundo branco
  
  //TEXTO
  fill(0);
  text("POLIMERIZA\u00c7\u00c3O:\nCadeia", width/2, height/12); //t\u00edtulo
  
  textFont(f, 12); //diminuimos a fonta para a apresenta\u00e7\u00e3o dos bot\u00f5es de pol\u00edmeros
  text("Pol\u00edmero formado:", width/10, height/5);
  
   //apresentamos o texto explicativo
  textFont(f, 14);
  text("O mon\u00f4mero inicialmente est\u00e1vel passa a apresentar um s\u00edtio reativo\n" +
       "a partir do momento em que sua dupla liga\u00e7\u00e3o se quebra na presen\u00e7a\n" +
       "de um iniciador (R).\n\n" +
       "O s\u00edtio reativo do mero estimula a quebra da liga\u00e7\u00e3o dupla de uma\n" +
       "pr\u00f3xima mol\u00e9cula de mon\u00f4mero, que se adiciona \u00e0 corrente\n" +
       "polim\u00e9rica at\u00e9 que um terminador (R') se adicione ao pol\u00edmer0\n" +
       " e cancele a reatividade do \u00faltimo mero da sequ\u00eancia.", width/2, 4*height/5);   
}

//DRAW/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
public void draw(){
  fill(255);  //colorimos o ret\u00e2ngulo
  noStroke();
  rectMode(CORNERS);
  rect(0, m[0].ypos - height/6, width, m[0].ypos + height/6); //atualizamos a \u00e1rea de anima\u00e7\u00e3o  
  anima(); 
  botaoDisplay();
  polimeroDisplay();
  legenda(width/15, 3*height/5);
  credito.display();
}

/////////FUN\u00c7\u00d5ES DO PROGRAMA///////////////////////////////////////////////////////////////////////////////////////////////////////////

//desenvolve a anima\u00e7\u00e3o
public void anima(){
  
  float r0 = dist(rx, m[0].ypos, m[0].xpos, m[0].ypos); //dist\u00e2ncia entre o radical de inicia\u00e7\u00e3o ou de termina\u00e7\u00e3o 
                                                        //e o centro da liga\u00e7\u00e3o dupla principal do primeiro mon\u00f4mero
  
  //a fun\u00e7\u00e3o age, obviamente, de forma diferente em cada etapa da anima\u00e7\u00e3o
  
  //inicia\u00e7\u00e3o
  if(etapa == "INICIA\u00c7\u00c3O")
    {
      textFont(f, 28);
      
      //o radical se aproxima do primeiro mon\u00f4mero at\u00e9 assumir a dist\u00e2ncia de liga\u00e7\u00e3o
      if(r0 > 5*comprimento/6)
        rx += vx;
        
      //com a aproxima\u00e7\u00e3o do radical, abrimos a liga\u00e7\u00e3o do mon\u00f4mero, ap\u00f3s ultrapassada
      //uma dist\u00e2ncia m\u00ednima  
      if(r0 < 10*comprimento/6)
        m[0].abrir(vx*PI*6/(5*comprimento));
    }
   
   //desenhamos o radical R (com exce\u00e7\u00e3o da etapa MON\u00d4MERO)
   if(etapa != "MON\u00d4MERO"){
      textAlign(CENTER);     
      pushMatrix();
      translate(rx, m[0].ypos);
      stroke(0);
      line(0, 0, comprimento/3, 0);
      fill(0xffFFA255); //LARANJA
      noStroke();
      ellipse(0, 0, comprimento/2, comprimento/2); //radical
      fill(0);
      text("R", 0, comprimento/10); //nomeamos o radical
      popMatrix();
   }
  
  //propaga\u00e7\u00e3o 
  if(etapa == "PROPAGA\u00c7\u00c3O"){
    textFont(f, 18);
    
    //propagamos a polimeriza\u00e7\u00e3o por meio da cria\u00e7\u00e3o de novos objetos da classe
    //Monomero, que se movimentam em dire\u00e7\u00e3o do \u00faltimo objeto desta classe at\u00e9
    //que seja atingida a dist\u00e2ncia de liga\u00e7\u00e3o, quando o objeto cessa seu movimento
    //e \u00e9, ent\u00e3o, criado um novo Monomero que executa o mesmo processo.
    
    if(m.length < 7){ //criamos um numero m\u00e1ximo de 7 monomeros
    
      //a dist\u00e2ncia de liga\u00e7\u00e3o \u00e9 a condi\u00e7\u00e3o para se criar um novo objeto   
      if(m[m.length - 1].xpos - m[0].xpos <= (m.length -1)*comprimento){ 
        //criamos e iniciamos o novo Monomero
        Monomero novo = new Monomero(width + 3*comprimento/2, m[0].ypos, 0);
        m = (Monomero[]) append(m, novo);
      }
      //se a dist\u00e2ncia ainda n\u00e3o for atingida, movimentamos o \u00faltimo mon\u00f4mero
      else
        {
         m[m.length - 1].andar(-vx, 0);
         //do mesmo modo que ocorre na inicia\u00e7\u00e3o, abrimos a liga\u00e7\u00e3o do \u00faltimo mon\u00f4mero ap\u00f3s
         //atingida uma dist\u00e2ncia m\u00ednima
         if(m[m.length - 1].xpos - m[0].xpos < comprimento*(m.length))
           m[m.length - 1].abrir(vx*PI/comprimento);
        }
      }
  }
  
  //termina\u00e7\u00e3o    
  if(etapa == "TERMINA\u00c7\u00c3O"){
    
    //nesta etapa executa-se um processo semelhante ao que aparece na inicia\u00e7\u00e3o,
    //por\u00e9m criamos um radical de termina\u00e7\u00e3o que se aproxima pela direita, at\u00e9
    //atingir a dist\u00e2ncia de liga\u00e7\u00e3o
    
    if(m.length == 7)
      r0 = dist(rx_, m[m.length - 2].ypos, m[m.length - 2].xpos, m[m.length - 2].ypos);
    else
      r0 = dist(rx_, m[m.length - 1].ypos, m[m.length - 1].xpos, m[m.length - 1].ypos);          
    if(r0 > 5*comprimento/6){
        rx_ -= vx;
    }
    pushMatrix();
    translate(rx_, m[m.length - 2].ypos);
    
    //desenhamos o radical terminador R'
    stroke(0);
    line(0, 0, -comprimento/3, 0);
    fill(0xffFC59E2);//ROSA
    noStroke();
    ellipse(0, 0, comprimento/2, comprimento/2);
    fill(0);
    text("R'", comprimento/30, comprimento/10);
    popMatrix();
    }  
  }  

//fun\u00e7\u00e3o que desenha todos os bot\u00f5es      
public void botaoDisplay(){
  rectMode(CENTER); 
  textFont(f, 12);
  for(int i = 0; i < especie.length; i++)
    especie[i].display();
  for(int i = 0; i < processo.length; i++)
    processo[i].display();
}  

//fun\u00e7\u00e3o que desenha os pol\u00edmeros, acionando o m\u00e9todo relativo ao pol\u00edmero escolhido
//em cada um dos objetos Monomero
public void polimeroDisplay(){
  if(polimero == "POLIETILENO")
    for(int i = 0; i < m.length; i++)
      m[i].displayEthylene();
  if(polimero == "TEFLON")
    for(int i = 0; i < m.length; i++)
      m[i].displayTFEthylene();
  if(polimero == "PVC")
    for(int i = 0; i < m.length; i++)
      m[i].displayPVC();
  if(polimero == "POLIPROPILENO")
    for(int i = 0; i < m.length; i++)
      m[i].displayPropylene();
  if(polimero == "ACR\u00cdLICO")
    for(int i = 0; i < m.length; i++)
      m[i].displayAcrylic();   
}

public void legenda(float x, float y){
  textAlign(LEFT);
  textFont(f, 12);
  pushMatrix();
  translate(x, y);
  fill(255);
  rect(70, 40, 140, 100);
  fill(0);
  noStroke();
  text("Legenda:", 0, 0);
  text("Carbono", 60, 15);
  fill(0xff91D6F7); //AZUL
  ellipse(50, 11, 10, 10);
  fill(0);
  text("Hidrog\u00eanio", 60, 30);
  fill(122);
  ellipse(50, 26, 10, 10);
  fill(0);
  text("Fl\u00faor", 60, 45);
  fill(0xffBC90FA);
  ellipse(50, 41, 10, 10);
  fill(0);
  text("Oxig\u00eanio", 60, 60);
  fill(0xffFC928F);
  ellipse(50, 56, 10, 10);
  popMatrix();
  textAlign(CENTER);
}
/////////MOUSE///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  

//ao clique do mouse:
public void mousePressed(){
  
  //analisamos se os bot\u00f5es foram acionados
   for(int i = 0; i < especie.length; i++)
     especie[i].mousePressed();
   
   for(int i = 0; i < processo.length; i++)
     processo[i].mousePressed(); 
  
  //para que n\u00e3o sobrem resqu\u00edcios dos cr\u00e9ditos nas \u00e1reas n\u00e3o atualizadas, as reescrevemos quando
  //retiramos os creditos
  
  if(credito.botao.situacao == "SELECIONADO" ){
    
    background(255); // fundo branco
  
    //TEXTO
    fill(0);
    
    textFont(f, 38); //escrevemos o t\u00edtulo com uma letra maior
    text("POLIMERIZA\u00c7\u00c3O:\nCadeia", width/2, height/12); //t\u00edtulo
  
    textFont(f, 12); //diminuimos a fonta para a apresenta\u00e7\u00e3o dos bot\u00f5es de pol\u00edmeros
    text("Pol\u00edmero formado:", width/10, height/5);
  
     //apresentamos o texto explicativo
    textFont(f, 14);
    text("O mon\u00f4mero inicialmente est\u00e1vel passa a apresentar um s\u00edtio reativo\n" +
         "a partir do momento em que sua dupla liga\u00e7\u00e3o se quebra na presen\u00e7a\n" +
         "de um iniciador (R).\n\n" +
         "O s\u00edtio reativo do mero estimula a quebra da liga\u00e7\u00e3o dupla de uma\n" +
         "pr\u00f3xima mol\u00e9cula de mon\u00f4mero, que se adiciona \u00e0 corrente\n" +
         "polim\u00e9rica at\u00e9 que um terminador (R') se adicione ao pol\u00edmer0\n" +
         " e cancele a reatividade do \u00faltimo mero da sequ\u00eancia.", width/2, 4*height/5);    
   }
   
   fill(255);  //colorimos o ret\u00e2ngulo
    noStroke();
    rectMode(CORNERS);
    rect(0, m[0].ypos - height/6, width, m[0].ypos + height/6); //atualizamos a \u00e1rea de anima\u00e7\u00e3o  
    anima(); 
    botaoDisplay();
    polimeroDisplay();
    legenda(width/15, 3*height/5); 
   
   //atualizamos a situa\u00e7\u00e3o do bot\u00e3o de cr\u00e9ditos
   credito.botao.mousePressed();  
   credito.display(); 
   
   /*if(mouseButton == LEFT)
     etapa ++;
   
   if(mouseButton == RIGHT || etapa > 3){
     etapa = 0;
     comprimento = 60;
     rx = - comprimento;
     m = new Monomero[1];
     m[0] = new Monomero(width/2, height/2 - 40, 0);
   }*/
     
   
  
/*  play = !play;
  Monomero novo;
  novo = new Monomero(width/2 - m.length*(comprimento), height/2, 0);
  if(!play)
    m = (Monomero[]) append(m, novo);
 */
}

//ao soltar o bot\u00e3o do mouse  
public void mouseReleased(){
  
  //se algum dos bot\u00f5es de pol\u00edmeros foi acionado com o clique,
  //os outros s\u00e3o liberados
  for(int i = 0; i < especie.length; i++){
    if(especie[i].situacao == "PRESSIONADO"){
      for(int j = 0; j < especie.length; j++)
        if(j != i)
          especie[j].libera();
      polimero = especie[i].texto;
    }
      especie[i].mouseReleased(); //se o bot\u00e3o foi acionado pelo clique, gerenciamos sua situa\u00e7\u00e3o    
  }
    
  //se o bot\u00e3o acionado foi 'in\u00edcio', inicializamos a anima\u00e7\u00e3o  
  if(processo[0].situacao == "PRESSIONADO"){
    etapa = "MON\u00d4MERO";
    lado = 1;
    comprimento = 60;
    rx = - comprimento;
    vx = 3;
    m = new Monomero[1];
    m[0] = new Monomero(width/2, height/2 , 0);
  }
  
  //se o bot\u00e3o de Cr\u00e9dito for acionado, apresentamos ou deixamos de apresentar o texto
  
  credito.botao.mouseReleased();
  
  //se o bot\u00e3o acionado foi 'avan\u00e7ar', modificamos o valor de 'etapa' para o pr\u00f3ximo processo  
  if(processo[1].situacao == "PRESSIONADO"){
    //'MONOMERO' --> 'INICIA\u00c7\u00c3O'
    if(etapa == "MON\u00d4MERO")
      etapa = "INICIA\u00c7\u00c3O";
    //'INICIA\u00c7\u00c3O' --> 'PROPAGA\u00c7\u00c3O'  
    else if(etapa == "INICIA\u00c7\u00c3O"){
      comprimento = 40; //a etapa propaga\u00e7\u00e3o adota uma escala reduzida, facilitando a visualiza\u00e7\u00e3o do processo
      m[0].xpos = width/2 - 3*comprimento;
      m[0].angle = PI;
      rx = m[0].xpos - 5*comprimento/6;
      vx = 5; //para agilizar a etapa de propaga\u00e7\u00e3o, aumentamos a velocidade
      etapa = "PROPAGA\u00c7\u00c3O";      
      textFont(f, 18);
    }
    //PROPAGA\u00c7\u00c3O --> TERMINA\u00c7\u00c3O
    else if(etapa == "PROPAGA\u00c7\u00c3O"){
      etapa = "TERMINA\u00c7\u00c3O";
      //colocamos o ultimo objeto Monomero em sua posi\u00e7\u00e3o final para garantir este
      //posicionamento
      if(m.length < 7){
        m[m.length - 1].xpos = m[0].xpos + (m.length -1)*comprimento;
        m[m.length - 1].angle = PI;
      }    
      rx_ = width + 3*comprimento/2;//o radical de termina\u00e7\u00e3o vem de fora da tela, aproximando-se pela direita
      vx = 3;
    }
  }
  
  
 /* for(int i = 0; i < processo.length; i++){
    if(processo[i].situacao == "PRESSIONADO")
      for(int j = 0; j <processo.length; j++)
          processo[j].libera();
    } */ 
    
    //os bot\u00f5es de anima\u00e7\u00e3o est\u00e3o sempre liberados, atuando apenas quando pressionados
    processo[0].libera();
    processo[1].libera();   
}
    


// BOT\u00c3O///

class Botao{
  float xpos, ypos; // coordenadas do centro do bot\u00e3o
  
  String texto, // guarda o texto a ser impresso no bot\u00e3o
  
         situacao, // guarda a situa\u00e7\u00e3o em que se encontra o bot\u00e3o, podendo estar "LIBERADO", "PRESSIONADO" ou "SELECIONADO"
  
         psituacao;  // guarda a situa\u00e7\u00e3o 'est\u00e1vel' que o bot\u00e3o assumira antes de ser pressionado pela \u00faltima vez
                     // (pode guardar "LIBERADO" ou "SELECIONADO") 
  
  float comprimento; // comprimento de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  float altura; // altura de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  
  //CONSTRUTORA SIMPLES//
  Botao(float _xpos, float _ypos, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    texto = _texto;
    situacao = "LIBERADO";        // a priore, o bot\u00e3o \u00e9 iniciado como se n\u00e3o estivesse ativado 
    psituacao = "SELECIONADO";    // caso queiramos que ele apresente-se 'selecionado' logo de
                                  // in\u00edcio, trocamos estas vari\u00e1veis apos a chamada da fun\u00e7\u00e3o
                                  // construtora (tratam-se de par\u00e2metros PUBLICOS)
                                  
    //comprimento = 12*texto.length();
    
    // dimens\u00f5es-padr\u00e3o
    altura = 20;    
    comprimento = 92;
  }

  //CONSTUTRUTORA EXTENDIDA (entramos com os valores de 'comprimento' e 'altura' do ret\u00e2ngulo interno do bot\u00e3o)
  Botao(float _xpos, float _ypos, float _comprimento, float _altura, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    comprimento = _comprimento;
    altura = _altura;
    texto = _texto;
    situacao = "LIBERADO";        // da mesma forma que na outra construtora 
    psituacao = "SELECIONADO"; 
    }

  //desenhamos o bot\u00e3o
  public void display(){
    noStroke();
    pushMatrix();
    translate(xpos, ypos); //origem: centro do bot\u00e3o
   
    // as cores dos ret\u00e2ngulos dependem da situa\u00e7\u00e3o em que o bot\u00e3o se encontra
    
    //ret\u00e2ngulo externo
    if(situacao == "LIBERADO")
      fill(180);
    else if(situacao == "PRESSIONADO")
      fill(200);
    else if(situacao == "SELECIONADO")
      fill(220);
    
    rect(0, 0, comprimento + 20, altura + 20); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo intermedi\u00e1rio
    if(situacao == "LIBERADO")
      fill(200);
    else if(situacao == "PRESSIONADO")
      fill(220);
    else if(situacao == "SELECIONADO")
      fill(180);
    
    rect(0, 0, comprimento + 10, altura + 10); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo interno
    if(situacao == "LIBERADO")
      fill(220);
    else if(situacao == "PRESSIONADO")
      fill(180);
    else if(situacao == "SELECIONADO")
      fill(200);
    
    rect(0, 0, comprimento , altura); // desenhamos o ret\u00e2ngulo
    
    //a cor do texto tamb\u00e9m depende da situa\u00e7\u00e3o do bot\u00e3o
    if(situacao == "PRESSIONADO")
      fill(255);
    else
      fill(0);
    
    text(texto, 0, 4); // escrevemos o texto
    
    popMatrix();  
  }
  
  //fun\u00e7\u00e3o chamada pelo clique do bot\u00e3o (embora o nome seja o mesmo da fun\u00e7\u00e3o da biblioteca interna
  //                                     do Processing, esta fun\u00e7\u00e3o n\u00e3o \u00e9 chamada automaticamente
  //                                     pelo clique do mouse. Portanto devemos cham\u00e1-la dentro da
  //                                     fun\u00e7\u00e3o mousePressed do Processing)
  public void mousePressed(){
    float dx = mouseX - xpos;
    float dy = mouseY - ypos;
    
    //se, no momento do clique do mouse, este estiver sobre o bot\u00e3o, o mesmo assume a situa\u00e7\u00e3o "PRESSIONADO"
    if(abs(dx) < (comprimento)/2 && abs(dy) < (altura)/2)
      situacao = "PRESSIONADO";    
  }
  
  //fun\u00e7\u00e3o chamada pela libera\u00e7\u00e3o do bot\u00e3o do mouse (vale o mesmo dito para a fun\u00e7\u00e3o mousePressed)
  public void mouseReleased(){
    
    /*if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = psituacao;
      psituacao = "SELECIONADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = psituacao;
      psituacao = "LIBERADO";
    }*/
    
    //se o bot\u00e3o foi pressionado, ap\u00f3s a libera\u00e7\u00e3o do mouse o primeiro assume a situa\u00e7\u00e3o "SELECIONADO"
    if(situacao == "PRESSIONADO"){
      situacao = "SELECIONADO";
      psituacao = "LIBERADO";
    }
      
  }
  
  //fun\u00e7\u00e3o que libera o bot\u00e3o
  public void libera(){
    psituacao = "SELECIONADO";
    situacao = "LIBERADO";
  }

}
class Credito{
  
  Botao botao;
  
  PFont f;
  
  boolean mais;
  
  Credito(){
    botao = new Botao(width - 40, 20, 45, 20, "Cr\u00e9ditos");
    f = loadFont("ArialUnicodeMS-11.vlw");
    mais = false;
  }

 public void display(){     
   textFont(f, 11);
   botao.display();
   rectMode(CORNERS);
   if( botao.situacao == "SELECIONADO" ){
     fill(240, 200);
     textAlign(LEFT);     
     if(mais){
       //rect(width/2, height/2, 400, 400);
       rect(width/2 - 200, height/2 - 200, width/2 + 200, height/2 + 200);
       fill(0);
       text( "\t\t                                                                            CR\u00c9DITOS" +
           "\n\nDesenvolvimento: Gustavo S. Jacomini (2\u00baano, Engenharia Civil-Escola Polit\u00e9cnica)" +
           "\n" + 
           "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia" + 
           "\n                                                                        Metal\u00fargica e de Materiais - Escola Polit\u00e9cnica)" +
           "\n\ncriado em:" + 
//           " Processing" + 
           "\n\n\nO meio:    'Processing' \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de" +  
           "\n                      desenvolvimento com foco principal nas artes visuais, apro-" +
           "\n                      veitando-se da plataforma Java e de uma comunidade virtual" + 
           "\n                      intensamente atuante atrav\u00e9s do compartilhamento de c\u00f3di-" + 
           "\n                      gos e bibliotecas atrav\u00e9s da internet." + 
           "\n\n                      Surgiu como iniciativa de Casey Reas e Ben Fry, pesquisa-" +
           "\n                      dores do Instituto de Tecnologia de Massachussets (MIT)," +
           "\n                      sendo, desde sua cria\u00e7\u00e3o,disponibilizado gratuitamente co-" +
           "\n                      mo software livre,acess\u00edvel a qualquer interessado a partir" + 
           "\n                      do download no site 'processing.org',onde podem ser en-" +
           "\n                      contradas informa\u00e7\u00f5es adicionais sobre 'Processing'." +    
           "\n\n\nApoio:     'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos"  + 
           "\n                      Materiais' \u00e9 integrante do 'Programa Ensinar com Pesquisa', iniciativa"  +
           "\n                      da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo,  \u00e0 qual"  +
           "\n                      expressamos nossos agradecimentos (Projeto 598 - Ano 2009).",width/2 - 190, height/2 - 170);
     }
     
     else if(mais == false){
       rect(width/2 - 200, height/2 - 200, width/2 + 200, height/2 + 30);
       fill(0);
       text( "\t\t                                                                            CR\u00c9DITOS" +
           "\n\nDesenvolvimento: Gustavo S. Jacomini (2\u00baano, Engenharia Civil-Escola Polit\u00e9cnica)" +
           "\n" + 
           "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia" + 
           "\n                                                                        Metal\u00fargica e de Materiais - Escola Polit\u00e9cnica)" +
           "\n\ncriado em:" +    
           "\n\n\nApoio:     'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos"  + 
           "\n                      Materiais' \u00e9 integrante do 'Programa Ensinar com Pesquisa', iniciativa"  +
           "\n                      da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo,  \u00e0 qual"  +
           "\n                      expressamos nossos agradecimentos (Projeto 598 - Ano 2009).",width/2 - 190, height/2 - 170);
       
     }
     textAlign(CENTER);
     
     if(!mais)
       fill(0, 0, 150);
     else if(mais)
       fill(150);
     
     if(abs(mouseX - (width/2 - 86)) < 30 && abs(mouseY - (height/2 - 68)) < 10){
       if(mousePressed)
         fill(255);
       else{
         if(!mais)
           fill(100, 100, 255);
         else if(mais)
           fill(200);
       }
     }
     
     text("Processing", width/2 - 86, height/2 - 68);
    
          
   }
   rectMode(CENTER);
 }
 
 class Botao{
  float xpos, ypos; // coordenadas do centro do bot\u00e3o
  
  String texto, // guarda o texto a ser impresso no bot\u00e3o
  
         situacao, // guarda a situa\u00e7\u00e3o em que se encontra o bot\u00e3o, podendo estar "LIBERADO", "PRESSIONADO" ou "SELECIONADO"
  
         psituacao;  // guarda a situa\u00e7\u00e3o 'est\u00e1vel' que o bot\u00e3o assumira antes de ser pressionado pela \u00faltima vez
                     // (pode guardar "LIBERADO" ou "SELECIONADO") 
  
  float comprimento; // comprimento de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  float altura; // altura de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  
  //CONSTRUTORA SIMPLES//
  Botao(float _xpos, float _ypos, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    texto = _texto;
    situacao = "LIBERADO";        // a priore, o bot\u00e3o \u00e9 iniciado como se n\u00e3o estivesse ativado 
    psituacao = "SELECIONADO";    // caso queiramos que ele apresente-se 'selecionado' logo de
                                  // in\u00edcio, trocamos estas vari\u00e1veis apos a chamada da fun\u00e7\u00e3o
                                  // construtora (tratam-se de par\u00e2metros PUBLICOS)
                                  
    //comprimento = 12*texto.length();
    
    // dimens\u00f5es-padr\u00e3o
    altura = 20;    
    comprimento = 92;
  }

  //CONSTUTRUTORA EXTENDIDA (entramos com os valores de 'comprimento' e 'altura' do ret\u00e2ngulo interno do bot\u00e3o)
  Botao(float _xpos, float _ypos, float _comprimento, float _altura, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    comprimento = _comprimento;
    altura = _altura;
    texto = _texto;
    situacao = "LIBERADO";        // da mesma forma que na outra construtora 
    psituacao = "SELECIONADO"; 
    }

  //desenhamos o bot\u00e3o
  public void display(){
    noStroke();
    pushMatrix();
    translate(xpos, ypos); //origem: centro do bot\u00e3o
   
    // as cores dos ret\u00e2ngulos dependem da situa\u00e7\u00e3o em que o bot\u00e3o se encontra
    
   /* //ret\u00e2ngulo externo
    if(situacao == "LIBERADO")
      fill(255 - 180);
    else if(situacao == "PRESSIONADO")
      fill(255 - 200);
    else if(situacao == "SELECIONADO")
      fill(255 - 220);
    
    rect(0, 0, comprimento + 20, altura + 20); // desenhamos o ret\u00e2ngulo
    */
    //ret\u00e2ngulo intermedi\u00e1rio
    if(situacao == "LIBERADO")
      fill(200);
    else if(situacao == "PRESSIONADO")
      fill(220);
    else if(situacao == "SELECIONADO")
      fill(180);
    
    rect(0, 0, comprimento + 10, altura + 10); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo interno
    if(situacao == "LIBERADO")
      fill(220);
    else if(situacao == "PRESSIONADO")
      fill(180);
    else if(situacao == "SELECIONADO")
      fill(200);
    
    rect(0, 0, comprimento , altura); // desenhamos o ret\u00e2ngulo
    
    //a cor do texto tamb\u00e9m depende da situa\u00e7\u00e3o do bot\u00e3o
    if(situacao == "PRESSIONADO")
      fill(255);
    else
      fill(0);
    
    text(texto, 0, 4); // escrevemos o texto
    
    popMatrix();  
  }
  
  //fun\u00e7\u00e3o chamada pelo clique do bot\u00e3o (embora o nome seja o mesmo da fun\u00e7\u00e3o da biblioteca interna
  //                                     do Processing, esta fun\u00e7\u00e3o n\u00e3o \u00e9 chamada automaticamente
  //                                     pelo clique do mouse. Portanto devemos cham\u00e1-la dentro da
  //                                     fun\u00e7\u00e3o mousePressed do Processing)
  public void mousePressed(){
    float dx = mouseX - xpos;
    float dy = mouseY - ypos;
    
    //se, no momento do clique do mouse, este estiver sobre o bot\u00e3o, o mesmo assume a situa\u00e7\u00e3o "PRESSIONADO"
    if(abs(dx) < (comprimento)/2 && abs(dy) < (altura)/2)
      situacao = "PRESSIONADO";
    
    //gerenciamos a apresenta\u00e7\u00e3o de informa\u00e7\u00f5es adicionais pelo clique sobre a palavra 'Processing'
    if(abs(mouseX - (width/2 - 86)) < 30 && abs(mouseY - (height/2 - 68)) < 10)
      mais = !mais;    
  }
  
  //fun\u00e7\u00e3o chamada pela libera\u00e7\u00e3o do bot\u00e3o do mouse (vale o mesmo dito para a fun\u00e7\u00e3o mousePressed)
  public void mouseReleased(){
    
    /*if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = psituacao;
      psituacao = "SELECIONADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = psituacao;
      psituacao = "LIBERADO";
    }*/
    
    //se o bot\u00e3o foi pressionado, ap\u00f3s a libera\u00e7\u00e3o do mouse o primeiro assume a situa\u00e7\u00e3o "SELECIONADO"
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = "SELECIONADO";
      psituacao = "LIBERADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = "LIBERADO";
      psituacao = "SELECIONADO";
    }
    
    
       
  }
  
  //fun\u00e7\u00e3o que libera o bot\u00e3o
  public void libera(){
    psituacao = "SELECIONADO";
    situacao = "LIBERADO";
  }

}
}
 
// MON\u00d4MERO///

class Monomero{
  
  float xpos, ypos, //coordenadas do centro da liga\u00e7\u00e3o dupla principal do mon\u00f4mero
  
        angle, //\u00e2ngulo de abertura da liga\u00e7\u00e3o dupla
  
        inc; //inclina\u00e7\u00e3o do mon\u00f4mero em rela\u00e7\u00e3o ao eixo horizontal
  
  float l; //vi\u00e1vel utilizada para alternar os sentidos de mon\u00f4meros sucessivos (assume os valores '1' ou '-1')
  
  //CONSTRUTORA//
  Monomero(float x, float y, float teta){
    xpos = x;
    ypos = y;
    inc = teta;
    angle = 0;
    l = lado;
    lado = -lado;    
  }
  
  //para facilitar a mudan\u00e7a do pol\u00edmero a ser apresentado, criamos uma fun\u00e7\u00e3o display() para cada
  //esp\u00e9cie quimica diferente

  //ETILENO
  public void displayEthylene(){
    
    float offset = (comprimento/30)*(PI - angle)/PI; //dist\u00e2ncia interna \u00e0 liga\u00e7\u00e3o dupla
    
    if(angle == PI)
      offset = 0;     //sistema de redund\u00e2ncia
    
    pushMatrix();
    translate(xpos, ypos);//origem: centro da liga\u00e7\u00e3o dupla 
    rotate(inc);// gira de 'inc'
    
    //desenha as liga\u00e7\u00f5es centrais
    pushMatrix();
    translate(- (comprimento/4), offset);//origem: centro do \u00e1tomo \u00e0 esquerda da liga\u00e7\u00e3o, deslocado de 'offset'
    rotate(angle);// uma das partes da liga\u00e7\u00e3o dupla abre de um angulo 'angle'    
    stroke(0);
    line(0, 0, (comprimento/4), 0);//desenhamos a metade da esquerda da liga\u00e7\u00e3o inferior
    popMatrix();
    
    pushMatrix();
    translate((comprimento/4), offset);//origem: centro do \u00e1tomo \u00e0 direita da liga\u00e7\u00e3o, deslocado de 'offset'
    rotate(PI - angle); // a outra parte da liga\u00e7\u00e3o dupla abre para o outro lado, simetricamente
    line(0, 0, (comprimento/4), 0);//desenhamos a metade da direita da liga\u00e7\u00e3o inferior
    popMatrix();
    
    line(- (comprimento/4), - offset, (comprimento/4), - offset);//desenhamos a liga\u00e7\u00e3o superior
    
    //desenha os \u00e1tomos e suas liga\u00e7\u00f5es
    pushMatrix();
    translate(- (comprimento/4), 0);//origem: centro do \u00e1tomo \u00e0 esquerda da liga\u00e7\u00e3o dupla
    pushMatrix();
    rotate((TWO_PI - angle/2)/3); //o \u00e2ngulo das outras liga\u00e7\u00f5es dos \u00e1tomos ligados pela liga\u00e7\u00e3o
                                  //dupla tamb\u00e9m dependem do valor de 'angle', uma vez que o 
                                  //\u00e1tomo de carbono assume hibridiza\u00e7\u00f5es distintas no mon\u00f4mero
                                  //e no pol\u00edmero
                                  
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(122);//CINZA
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0); //origem: centro do \u00e1tomo \u00e0 direita da liga\u00e7\u00e3o dupla
    pushMatrix();
    rotate((PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate(-(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    popMatrix();
    
    fill(0xff91D6F7);//AZUL 
    ellipse(-(comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    popMatrix();
  }
  
  //TEFLON
  public void displayTFEthylene(){
    
    // o procedimento de desenho \u00e9 an\u00e1logo ao do mon\u00f4mero de etileno
    
    float offset = (comprimento/30)*(PI - angle)/PI; //dist\u00e2ncia interna \u00e0 liga\u00e7\u00e3o dupla
    
    if(angle == PI)
      offset = 0;  //sistema de redund\u00e2ncia
    
    pushMatrix();
    translate(xpos, ypos);
    rotate(inc);
    
    //desenha as liga\u00e7\u00f5es centrais
    pushMatrix();
    translate(- (comprimento/4), offset);
    rotate(angle); //uma das partes da liga\u00e7\u00e3o dupla abre de um angulo 'angle'
    
    stroke(0);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    pushMatrix();
    translate((comprimento/4), offset);
    rotate(PI - angle);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    line(- (comprimento/4), - offset, (comprimento/4), - offset);
    
    //desenha os \u00e1tomos e suas liga\u00e7\u00f5es
    pushMatrix();
    translate(- (comprimento/4), 0);
    pushMatrix();
    rotate((TWO_PI - angle/2)/3);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(0xffBC90FA);//ROXO
    ellipse((5*comprimento/12), 0, 1.2f*(comprimento/5), 1.2f*(comprimento/5)); //cloro
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, 1.2f*(comprimento/5), 1.2f*(comprimento/5)); //cloro
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0);
    pushMatrix();
    rotate((PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, 1.2f*(comprimento/5), 1.2f*(comprimento/5)); //cloro
    popMatrix();
    pushMatrix();
    rotate(-(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, 1.2f*(comprimento/5), 1.2f*(comprimento/5)); //cloro
    popMatrix();
    popMatrix();
    
    fill(0xff91D6F7);//AZUL
    ellipse(-(comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5));  //carbono
    popMatrix();
  }
  
   //PVC
   public void displayPVC(){
    
    // o procedimento de desenho \u00e9 an\u00e1logo ao do mon\u00f4mero de etileno
    
    float offset = (comprimento/30)*(PI - angle)/PI;
    if(angle == PI)
      offset = 0;
    
    pushMatrix();
    translate(xpos, ypos);
    rotate(inc);
    //desenha as liga\u00e7\u00f5es centrais
    pushMatrix();
    translate(- (comprimento/4), offset);
    rotate(angle);//uma das partes da liga\u00e7\u00e3o dupla abre de um angulo 'angle'
    
    stroke(0);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    pushMatrix();
    translate((comprimento/4), offset);
    rotate(PI - angle);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    line(- (comprimento/4), - offset, (comprimento/4), - offset);
    
    //desenha os \u00e1tomos e suas liga\u00e7\u00f5es
    pushMatrix();
    translate(- (comprimento/4), 0);
    pushMatrix();
    rotate((TWO_PI - angle/2)/3);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(122); //CINZA
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0);
    pushMatrix();
    rotate(l*(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate(l*(-(PI + angle/2)/3));
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(0xffBC90FA);//ROXO
    ellipse((5*comprimento/12), 0, 1.2f*(comprimento/5), 1.2f*(comprimento/5)); //cloro
    popMatrix();
    popMatrix();
    
    fill(0xff91D6F7); //AZUL
    ellipse(-(comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    popMatrix();
  }
  
  //PROPILENO  
  public void displayPropylene(){
    
    // o procedimento de desenho \u00e9 an\u00e1logo ao do mon\u00f4mero de etileno
    
    float offset = (comprimento/30)*(PI - angle)/PI;
    if(angle == PI)
      offset = 0;
    
    pushMatrix();
    translate(xpos, ypos);
    rotate(inc);
    
    //desenha as liga\u00e7\u00f5es centrais
    pushMatrix();
    translate(- (comprimento/4), offset);
    rotate(angle);//uma das partes da liga\u00e7\u00e3o dupla abre de um angulo 'angle'
    stroke(0);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    
    pushMatrix();
    translate((comprimento/4), offset);
    rotate(PI - angle);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    line(- (comprimento/4), - offset, (comprimento/4), - offset);
    
    //desenha os \u00e1tomos e suas liga\u00e7\u00f5es
    pushMatrix();
    translate(- (comprimento/4), 0);
    pushMatrix();
    rotate((TWO_PI - angle/2)/3);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(122); //CINZA
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0);
    pushMatrix();
    rotate(l*(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate(l*(-(PI + angle/2)/3));
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    //noStroke();
    //ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5));
    pushMatrix();
    translate((5*comprimento/12), 0);
    line(0, 0, (4*comprimento/12), 0);
    noStroke();
    ellipse((4*comprimento/12), 0, .9f*(comprimento/5), .9f*(comprimento/5)); //hidrog\u00eanio (este \u00e1tomo aparece menor para que 
                                                                            //pare\u00e7a mais distante, sendo que est\u00e1 atr\u00e1s do
                                                                            //plano da liga\u00e7\u00e3o dupla)
    pushMatrix();
    rotate(-PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5));
    popMatrix();
    pushMatrix();
    rotate(PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    fill(0xff91D6F7); //AZUL
    ellipse(0, 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    popMatrix();
    
    popMatrix();
    popMatrix();
    
    fill(0xff91D6F7); //AZUL
    ellipse(-(comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    popMatrix();
  } 
  
  //ACR\u00cdLICO
  public void displayAcrylic(){
    
    // o procedimento de desenho \u00e9 an\u00e1logo ao do mon\u00f4mero de etileno
    
    float offset = (comprimento/30)*(PI - angle)/PI;
    if(angle == PI)
      offset = 0;
    
    pushMatrix();
    translate(xpos, ypos);
    rotate(inc);
    
    //desenha as liga\u00e7\u00f5es centrais
    pushMatrix();
    translate(- (comprimento/4), offset);
    rotate(angle);//uma das partes da liga\u00e7\u00e3o dupla abre de um angulo 'angle'
    
    stroke(0);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    pushMatrix();
    translate((comprimento/4), offset);
    rotate(PI - angle);
    line(0, 0, (comprimento/4), 0);
    popMatrix();
    line(- (comprimento/4), - offset, (comprimento/4), - offset);
    
    //desenha os \u00e1tomos e suas liga\u00e7\u00f5es
    pushMatrix();
    translate(- (comprimento/4), 0);
    pushMatrix();
    rotate((TWO_PI - angle/2)/3);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    fill(122); //CINZA
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate((2*TWO_PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    popMatrix();
    pushMatrix();
    translate( (comprimento/4), 0);
    pushMatrix();
    rotate(l*(PI + angle/2)/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    //noStroke();
    //ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5));
    
    pushMatrix();//para desenhar a metila
    translate((5*comprimento/12), 0);
    line(0, 0, (4*comprimento/12), 0);
    noStroke();
    ellipse((4*comprimento/12), 0, .9f*(comprimento/5), .9f*(comprimento/5)); //hidrog\u00eanio
    pushMatrix();
    rotate(-PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate(PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    fill(0xff91D6F7);//AZUL
    ellipse(0, 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    popMatrix();
    popMatrix();//fim da metila
    
    pushMatrix();
    rotate(l*(-(PI + angle/2)/3));
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    //noStroke();
    //ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5));
    pushMatrix();
    translate((5*comprimento/12), 0);//pulamos para o carbono do radical
    pushMatrix();
    rotate(-PI/3);
    line(0, (comprimento/30), (5*comprimento/12), (comprimento/30));
    line(0, -(comprimento/30), (5*comprimento/12), -(comprimento/30));
    noStroke();
    fill(0xffFC928F); // ROSA
    ellipse((5*comprimento/12), 0, 1.1f*(comprimento/5), 1.1f*(comprimento/5));//desenhamos o oxig\u00eanio com liga\u00e7\u00e3o dupla
    popMatrix();
    pushMatrix();
    rotate(PI/3);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    translate((5*comprimento/12), 0);
    
    pushMatrix();//para desenhar a metila
    rotate(-PI/3);
    line(0, 0, (5*comprimento/12), 0);    
    translate((5*comprimento/12), 0);
    line(0, 0, (4*comprimento/12), 0);
    noStroke();
    fill(122); //CINZA
    ellipse((4*comprimento/12), 0, .9f*(comprimento/5), .9f*(comprimento/5)); //hidrog\u00eanio
    pushMatrix();
    rotate(-PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    pushMatrix();
    rotate(PI/4);
    stroke(0);
    line(0, 0, (5*comprimento/12), 0);
    noStroke();
    ellipse((5*comprimento/12), 0, (comprimento/5), (comprimento/5)); //hidrog\u00eanio
    popMatrix();
    fill(0xff91D6F7);//AZUL
    ellipse(0, 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    popMatrix();
    fill(0xffFC928F); // ROSA
    ellipse(0, 0, 1.1f*(comprimento/5), 1.1f*(comprimento/5));//desenhamos o oxig\u00eanio
    popMatrix();//fim da metila
    
    fill(0xff91D6F7);//AZUL
    ellipse(0, 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    popMatrix();
    popMatrix();
    popMatrix();
    
    ellipse(-(comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    ellipse((comprimento/4), 0, 1.3f*(comprimento/5), 1.3f*(comprimento/5)); //carbono
    popMatrix();
  }
  
    //fun\u00e7\u00e3o que abre a liga\u00e7\u00e3o dupla
    public void abrir(float omega){
      if(angle < PI)
        angle += omega;
      else
        angle = PI;  
    }
    
    //fun\u00e7\u00e3o que fecha a liga\u00e7\u00e3o dupla
    public void fechar(float omega){
      if(angle >0)
      angle -= omega;
    } 
    
    //fun\u00e7\u00e3o que faz o mon\u00f4mero girar em rela\u00e7\u00e3o ao eixo z
    public void girar(float teta){
      inc += teta;
    }
    
    //fun\u00e7\u00e3o que faz o mon\u00f4mero se movimentar no plano xy
    public void andar(float vx, float vy){
      xpos += vx;
      ypos += vy;
    }
    
    //devolve a dist\u00e2ncia entre este e um outro mon\u00f4mero 
    public float distancia(Monomero m){
      return dist(xpos, ypos, m.xpos, m.ypos);
    }
}


  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Polimerizacao_Cadeia" });
  }
}
